part1_load	equ	$0e00
part1_exec	equ	$0e00
part1_bcd	equ	$7279

; bin2cas.pl will be called with arguments to make it output all but the last
; two bytes as an elongated header block, then the last two on their own as
; data.

		org	$01da
		fcc	/DEMO    /	; filename
		fcb	$02		; file type: machine code
		fcb	$00		; ascii flag: binary
		fcb	$00		; gap flag: continuous
colon		fdb	$3a00		; exec address (convenient ':')
		fdb	$00a6		; load address: BASIC next

		; now follows the actual loader code
		;org	$01e9

exec
		setdp	$00

		ldx	#part1_load
		ldu	#part1_bcd
		bsr	load_part

		ldd	#$0402
		std	$0088
		ldx	#press_space
		bsr	out_string
10		jsr	[$a000]		; INCH
		cmpa	#$20
		bne	10B
		jmp	part1_exec

load_part	; d = count chars, x = load address
		stx	$007e
		jsr	[$a004]		; CSRDON
		stu	$041e
10		jsr	[$a006]		; BLKIN
		bne	do_io_error
		stx	$007e
		ldd	$041e
		decb
		cmpb	#$70
		bhs	20F
		deca
		ldb	#$79
20		std	$041e
		lda	$007c
		inca
		bne	10B
cas_off		lda	$ff21
		anda	#$f7
		sta	$ff21
do_rts		rts

do_io_error	bsr	cas_off
		ldx	#io_error
		bsr	out_string
1		bra	1B
out_string	lda	,x+
		beq	do_rts
1		jsr	[$a002]		; OUTCH
		bra	out_string

press_space	fcc	"PRESS SPACE",0
io_error	fcc	"I/O ERROR",0

		; last five bytes will be in a separate data block:
		fdb	colon
		jmp	>exec
